﻿Imports DesktopReader.Constants

Public Class frmMain
#Region "Variables"
    'Create reader
    Dim USBReader As DesktopReader.Reader
    Dim listcboxKey As New List(Of ComboBox)
    Dim arrcboxWriteData(15) As ComboBox
    Dim listEntolledTemplates As New List(Of Byte())
#End Region
#Region "Form Load/Close"
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles Me.Load
        subClearText()
        Dim X, Y As Integer
        For X = 0 To 39
            cboxSector.Items.Add(X.ToString)
        Next
        cboxSector.Text = "0"
        For X = 0 To 15
            cboxBlock.Items.Add(X.ToString)
        Next
        cboxBlock.Text = "0"
        listcboxKey.Add(cboxKey0)
        listcboxKey.Add(cboxKey1)
        listcboxKey.Add(cboxKey2)
        listcboxKey.Add(cboxKey3)
        listcboxKey.Add(cboxKey4)
        listcboxKey.Add(cboxKey5)
        For Each cbox As ComboBox In listcboxKey
            For X = 0 To 255
                cbox.Items.Add(X.ToString)
            Next
            cbox.Text = "255"
        Next
        For X = 0 To 15
            arrcboxWriteData(X) = New ComboBox
            arrcboxWriteData(X).Width = 45
            arrcboxWriteData(X).DropDownStyle = ComboBoxStyle.DropDownList
            flpBlockDataWrite.Controls.Add(arrcboxWriteData(X))
            arrcboxWriteData(X).Visible = True
            For Y = 0 To 255
                arrcboxWriteData(X).Items.Add(Y.ToString)
            Next
            arrcboxWriteData(X).Text = "0"
        Next
        comboSecurityLevel.Text = "4"
        comboTemplateToReadFromCard.Text = "1"
        comboFingerToWriteInCard.Text = "1"
        comboFingerToDeleteFromCard.Text = "1"
        comboTimeout.Text = "3000"
        'Initialise reader
        USBReader = New DesktopReader.Reader
        'Add event of reader connected/disconnected
        AddHandler USBReader.USBEvent, AddressOf USBEventHandler
        'As at initialisation of the dll card reader may be already connected to PC, check for AttachedDevice property
        Text = "USB reader dll demo: " & My.Application.Info.Version.ToString & " Desktopr reader Dll version: " & USBReader.GetType.Assembly.GetName.Version.ToString
        EnableControl(USBReader.AttachedDevice)
        'Display reader firmware version
        lblVersion.Text = USBReader.AttachedDeviceVersion
    End Sub
    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        'Remove event of reader connected/disconnected
        RemoveHandler USBReader.USBEvent, AddressOf USBEventHandler
        USBReader.Dispose()
        USBReader = Nothing
    End Sub
#End Region
#Region "Form comands"
    Private Sub btnGetCardID_Click(sender As Object, e As EventArgs) Handles btnGetCardID.Click
        btnGetCardID.Enabled = False
        Try
            subClearText()
            Dim CardType As Byte = CardTypes.EM4100
            If rbMifare.Checked Then CardType = CardTypes.MIFARE
            If rbHID.Checked Then CardType = CardTypes.HID
            If rbAWID.Checked Then CardType = CardTypes.AWID
            'Ask reader for card number
            Dim Resault As ReadIDResault = USBReader.ReadCardID(CardType)
            'Display returned Error code
            lblErrorCode.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
            'Check if operation has no error and display number
            If Resault.ErrorCode = ErrorCodes.OK Then
                lblCardType.Text = [Enum].GetName(GetType(CardTypes), Resault.CardType)
                'Display Mifare card type
                If Resault.CardType = CardTypes.MIFARE Then lblMifareType.Text = [Enum].GetName(GetType(MifareTypes), Resault.MifareType)
                'Display card ID byte array
                lblID.Text = Join(Array.ConvertAll(Resault.ID, New Converter(Of Byte, String)(AddressOf ConvertByteToString)), ", ")
                'Display full card ID as nuber
                Dim decID As Decimal = ByteToDecimal(Resault.ID)
                lblID_Decimal.Text = decID.ToString
                'Display 7 byte UID converted to 4 byte NUI (only for Mifare 7 byte cards
                lblIDConverted.Text = Join(Array.ConvertAll(Resault.IDConverted7to4, New Converter(Of Byte, String)(AddressOf ConvertByteToString)), ", ")
                'Display converted 4 byte ID as single number
                lblID_Converted_Decimal.Text = BitConverter.ToUInt32(Resault.IDConverted7to4, 0).ToString
                'Display ID length (bits)
                lblIDSize.Text = Resault.UIDLength.ToString
            End If
        Catch
        End Try
        btnGetCardID.Enabled = True
    End Sub
    Private Sub btnReadBlock_Click(sender As Object, e As EventArgs) Handles btnReadBlock.Click
        TableLayoutPanel2.Enabled = False
        subClearText()
        'Select key type for sector access
        Dim KeyType As Byte = MifareKeys.KeyA
        If rbB.Checked Then KeyType = MifareKeys.KeyB
        'Assemble key array
        Dim key(5) As Byte
        For X As Integer = 0 To 5
            key(X) = CByte(listcboxKey(X).Text)
        Next
        'Read block
        Dim Resault As ReadBlockResault = USBReader.ReadMifareClassicBlock(KeyType, key, CByte(cboxSector.Text), CByte(cboxBlock.Text))
        'Display returned Error code
        lblReadBlockResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
        'Check if operation has no error and display block content
        If Resault.ErrorCode = ErrorCodes.OK Then
            txtClassicData.Text = Join(Array.ConvertAll(Resault.BlockData, New Converter(Of Byte, String)(AddressOf ConvertByteToString)), ", ")
        End If
        TableLayoutPanel2.Enabled = True
    End Sub
    Private Sub btnWriteBlock_Click(sender As Object, e As EventArgs) Handles btnWriteBlock.Click
        btnReadBlock.Enabled = False
        btnWriteBlock.Enabled = False
        subClearText()
        'Select key type for sector access
        Dim KeyType As Byte = MifareKeys.KeyA
        If rbB.Checked Then KeyType = MifareKeys.KeyB
        'Assemble key array
        Dim key(5) As Byte
        For X As Integer = 0 To 5
            key(X) = CByte(listcboxKey(X).Text)
        Next
        'Assemble block content
        Dim Data(15) As Byte
        For X As Integer = 0 To 15
            Data(X) = CByte(arrcboxWriteData(X).Text)
        Next
        'Write data to card
        Dim Resault As Integer = USBReader.WriteMifareClassicBlock(KeyType, key, CByte(cboxSector.Text), CByte(cboxBlock.Text), Data)
        'Display operation resault
        lblReadBlockResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault)
        btnReadBlock.Enabled = True
        btnWriteBlock.Enabled = True
    End Sub
    Private Sub btnGetFinger_Click(sender As Object, e As EventArgs) Handles btnGetFinger.Click
        tlpBiometry.Enabled = False
        Try
            subClearText()
            txtTemplateArray.Clear()
            'Read template from card
            Dim Resault As FingerData = USBReader.GetFingerTemlate
            'Display returned Error code
            lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
            'If there is no error
            If Resault.ErrorCode = ErrorCodes.OK Then
                'display template byte array in text box
                txtTemplateArray.Text = Join(Array.ConvertAll(Resault.Template, New Converter(Of Byte, String)(AddressOf ConvertByteToString)), ", ")
                listEntolledTemplates.Add(Resault.Template)
                lblEnrolledFingers.Text = listEntolledTemplates.Count.ToString
                comboWriteTemplateToCard.Items.Add(lblEnrolledFingers.Text)
                comboWriteTemplateToCard.Text = lblEnrolledFingers.Text
                btnWriteFinger.Enabled = True
                'Check is it Suprema (BIOPROX-USB) or DP (B100PROX-USB) template
                If Resault.TemplateType = FingerTemplateTypes.Suprema Then
                    lblTemplateType.Text = "Suprema"
                    lblQuality.Text = Resault.Quality.ToString & " %"
                    comboFingerToVerify.Enabled = True
                    comboFingerToVerify.Items.Add(lblEnrolledFingers.Text)
                    comboFingerToVerify.Text = lblEnrolledFingers.Text
                    btnVerify.Enabled = True
                    btnFindMatch.Enabled = True
                    comboWriteTemplateToCard.Enabled = True
                Else
                    lblTemplateType.Text = "DP"
                End If
            End If
        Catch
        End Try
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnWriteFinger_Click(sender As Object, e As EventArgs) Handles btnWriteFinger.Click
        tlpBiometry.Enabled = False
        Try
            subClearText()
            'Write template to card
            Dim response As Integer = USBReader.WriteFingerTemplateToCard(CByte(comboFingerToWriteInCard.Text), listEntolledTemplates(CInt(comboWriteTemplateToCard.Text) - 1))
            'Display operation resault
            lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), response)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnReadFingerFromCard_Click(sender As Object, e As EventArgs) Handles btnReadFingerFromCard.Click
        tlpBiometry.Enabled = False
        Try
            subClearText()
            lblBiometryResponse.Text = ""
            'Read finger from card
            Dim Resault As FingerData = USBReader.ReadFingerFromCard(CByte(comboTemplateToReadFromCard.Text))
            'Display operation resault
            lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
            'If OK, display template in textbox
            If Resault.ErrorCode = ErrorCodes.OK Then
                txtTemplateArray.Text = Join(Array.ConvertAll(Resault.Template, New Converter(Of Byte, String)(AddressOf ConvertByteToString)), ", ")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnDeleteFingerData_Click(sender As Object, e As EventArgs) Handles btnDeleteFingerData.Click
        tlpBiometry.Enabled = False
        subClearText()
        'Delete finger from card
        Dim response As Integer = USBReader.DeleteFingerData(CByte(comboFingerToDeleteFromCard.Text))
        'Display returned Error code
        lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), response)
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnFormatFOCCard_Click(sender As Object, e As EventArgs) Handles btnFormatFOCCard.Click
        tlpBiometry.Enabled = False
        subClearText()
        'Remove fingerprint application from card
        Dim response As Integer = USBReader.UninstallFingerprintFromCard
        'Display returned Error code
        lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), response)
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnVerify_Click(sender As Object, e As EventArgs) Handles btnVerify.Click
        tlpBiometry.Enabled = False
        Try
            subClearText()
            Dim TemplateFromReader As Byte()
            'Get live finger template from reader
            Dim Resault As FingerData = USBReader.GetFingerTemlate
            If Resault.ErrorCode = ErrorCodes.OK Then
                TemplateFromReader = Resault.Template
            Else
                'Display returned Error code and exit
                lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
                Exit Sub
            End If
            'Compare templates
            Dim Match As MatchResault = USBReader.CompareTemplates(listEntolledTemplates(CInt(comboFingerToVerify.Text) - 1), TemplateFromReader, 3)
            'Display returned Error code
            lblBiometryResponse.Text = [Enum].GetName(GetType(MatchErrorCodes), Match.ErrorCode)
            'Display match resault
            If Match.ErrorCode = MatchErrorCodes.OK Then
                If Match.Match Then
                    lblBiometryResponse.Text &= " - Finger MATCH with template " & comboFingerToVerify.Text
                Else
                    lblBiometryResponse.Text &= " - Finger DOES NOT MATCH with template " & comboFingerToVerify.Text
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        tlpBiometry.Enabled = True
    End Sub
    Private Sub btnClearFingers_Click(sender As Object, e As EventArgs) Handles btnClearFingers.Click
        comboFingerToVerify.Items.Clear()
        comboFingerToVerify.Enabled = False
        comboWriteTemplateToCard.Items.Clear()
        comboWriteTemplateToCard.Enabled = False
        listEntolledTemplates.Clear()
        lblEnrolledFingers.Text = "0"
        btnVerify.Enabled = False
        btnFindMatch.Enabled = False
    End Sub
    Private Sub comboSecurityLevel_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboSecurityLevel.SelectedIndexChanged
        'Set security level
        If USBReader IsNot Nothing Then USBReader.SecurityLevel = CInt(comboSecurityLevel.Text)
    End Sub
    Private Sub checkFastMode_CheckedChanged(sender As Object, e As EventArgs) Handles checkFastMode.CheckedChanged
        'Set fast mode
        If USBReader IsNot Nothing Then USBReader.FastMode = checkFastMode.Checked
    End Sub
    Private Sub btnFindMatch_Click(sender As Object, e As EventArgs) Handles btnFindMatch.Click
        tlpBiometry.Enabled = False
        Try
            subClearText()
            Dim TemplateFromReader As Byte()
            'Get live finger template from reader
            Dim Resault As FingerData = USBReader.GetFingerTemlate
            If Resault.ErrorCode = ErrorCodes.OK Then
                TemplateFromReader = Resault.Template
            Else
                'Display returned Error code and exit
                lblBiometryResponse.Text = [Enum].GetName(GetType(ErrorCodes), Resault.ErrorCode)
                Exit Sub
            End If
            'Check for match
            Dim FindMatch As FindMatchResault = USBReader.FindMatch(TemplateFromReader, listEntolledTemplates.ToArray, CInt(comboTimeout.Text))
            'Display error code
            lblBiometryResponse.Text = [Enum].GetName(GetType(MatchErrorCodes), FindMatch.ErrorCode)
            'Display match resault
            If FindMatch.ErrorCode = MatchErrorCodes.OK Then
                If FindMatch.MatchIndex > -1 Then
                    lblBiometryResponse.Text &= " - Finger MATCH with template " & (FindMatch.MatchIndex + 1).ToString
                Else
                    lblBiometryResponse.Text &= " - Finger  MATCH NOT FOUND"
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        tlpBiometry.Enabled = True
    End Sub
#End Region
#Region "Functions"
    Private Function ConvertByteToString(ByVal b As Byte) As String
        Return b.ToString
    End Function
    Private Function ConvertStringToByte(ByVal S As String) As Byte
        Return CByte(S)
    End Function
    Private Sub subClearText()
        lblErrorCode.Text = ""
        lblCardType.Text = ""
        lblMifareType.Text = ""
        lblID.Text = ""
        lblID_Decimal.Text = ""
        lblIDConverted.Text = ""
        lblID_Converted_Decimal.Text = ""
        lblIDSize.Text = ""
        lblReadBlockResponse.Text = ""
        lblTemplateType.Text = ""
        lblQuality.Text = ""
        lblBiometryResponse.Text = ""
    End Sub
    Sub EnableControl(readertype As Integer)
        lblDevice.Text = [Enum].GetName(GetType(Devices), readertype)
        Select Case readertype
            Case Devices.B100PROXUSB
                btnGetCardID.Enabled = True
                flpMifareRW.Enabled = True
                tlpBiometry.Enabled = True
                flpBioprox.Enabled = False
            Case Devices.BIOPROXUSB
                btnGetCardID.Enabled = True
                flpMifareRW.Enabled = True
                tlpBiometry.Enabled = True
                flpBioprox.Enabled = True
            Case Devices.PROXE, Devices.PROXUSB
                btnGetCardID.Enabled = True
                flpMifareRW.Enabled = True
                tlpBiometry.Enabled = False
            Case Devices.NONE
                btnGetCardID.Enabled = False
                flpMifareRW.Enabled = False
                tlpBiometry.Enabled = False
        End Select

    End Sub
    Private Function ByteToDecimal(bytes As Byte()) As Decimal
        If bytes.Count <> 16 Then
            ReDim Preserve bytes(16)
        End If
        Dim bits(3) As Int32
        For i As Integer = 0 To 15 Step 4
            bits(i \ 4) = BitConverter.ToInt32(bytes, i)
        Next
        Return New Decimal(bits)
    End Function
#End Region
#Region "DLL events"
    'Reader connected/disconnected event handler
    Sub USBEventHandler(sender As Object, e As DesktopReader.USBEventArgs)
        lblVersion.Text = e.version
        EnableControl(e.device)
    End Sub
#End Region
End Class